use std::collections::HashMap;

use logos::{Lexer, Logos};

#[derive(Logos, Debug, PartialEq)]
pub enum Token {
    #[regex("[a-zA-Z\\d\\w]+", |lex| lex.slice().to_owned())]
    Text(String),
    #[token("(")]
    ParenOpen,
    #[token(")")]
    ParenClose,
    #[regex(r#""([^"\\]|\\["\\bnfrt]|u[a-fA-F0-9]{4})*""#, |lex| lex.slice().to_owned())]
    String(String),
    #[token("=")]
    Equals,
    #[token("*")]
    Asterisk,
    #[token("_")]
    Underscore,
    #[token("\\")]
    Backslash,
    #[token("~")]
    WavyThing,
    #[token("✨")]
    Sparkles,
    #[token("|| ")]
    HeadingLevelIndicator,
    #[token("\n")]
    Newline,
}

#[derive(Debug)]
pub enum LanguageStructureThingy {
    Text(String),
    Sexpression {
        name: String,
        attrs: HashMap<String, String>,
        content: Box<LanguageStructureThingy>,
    },
}

pub fn parse_the_shit_out_of_this_but_manually(text: &str) -> Vec<LanguageStructureThingy> {
    let mut lex = Token::lexer(text);
    let mut r = Vec::new();

    loop {
        match lex.next() {
            Some(Ok(Token::Text(s))) => r.push(LanguageStructureThingy::Text(s)),
            Some(Ok(Token::Newline)) => r.push(LanguageStructureThingy::Text("\n".to_owned())),
            Some(Ok(Token::ParenOpen)) => hehe_sexpression_funy(&mut r, &mut lex),
            Some(Ok(Token::ParenClose)) => todo!(),
            Some(Ok(Token::String(_))) => todo!(),
            Some(Ok(Token::Equals)) => todo!(),
            Some(Ok(Token::Asterisk)) => todo!(),
            Some(Ok(Token::Underscore)) => todo!(),
            Some(Ok(Token::Backslash)) => todo!(),
            Some(Ok(Token::WavyThing)) => todo!(),
            Some(Ok(Token::Sparkles)) => todo!(),
            Some(Ok(Token::HeadingLevelIndicator)) => todo!(),
            Some(Err(e)) => panic!("mauuu~ :(, e: {e:?}"),
            None => break,
        }
    }

    r
}

fn hehe_sexpression_funy(r: &mut Vec<LanguageStructureThingy>, lex: &mut Lexer<'_, Token>) {
    if let Some(Ok(Token::Text(s))) = lex.next() {
        let strs = s.trim_start().split_whitespace().collect::<Vec<&str>>();

        let name = strs[0].to_owned();
        let mut attrs = HashMap::new();

        if strs.len() == 1 {
        } else if strs.len() == 2 && (lex.next() == Some(Ok(Token::Equals))) {
            if let Some(Ok(Token::Text(next))) = lex.next() {
                let _ = attrs.insert(strs[1].to_owned(), next.trim_end().to_owned());
            }
        } else {
            todo!()
        }

        let content = if let Some(Ok(Token::String(s))) = lex.next() {
            Box::new(LanguageStructureThingy::Text(s))
        } else {
            todo!()
        };

        r.push(LanguageStructureThingy::Sexpression {
            name,
            attrs,
            content,
        });
        if let Some(Ok(Token::ParenClose)) = lex.next() {
            return;
        }
        // handle other things too
        todo!()
    }
}
